<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>updateUser</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css" />
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>
<body>
    <div class="container jumbotron">
        <div class="text-center">
            <h3>Chi tiết User</h3>
        </div>
        <div class="row form-group">
            <div class="col-sm-4">
                <label for="">First Name</label>
            </div>
            <div class="col-sm-8">
                <input type="text" class="form-control" placeholder="Nhập firstname ..." id="inp-firstname" />
            </div>
        </div>
        <div class=" row form-group">
            <div class="col-sm-4">
                <label for="">Last Name</label>
            </div>
            <div class="col-sm-8">
                <input type="text" class="form-control" placeholder="Nhập lastname ..." id="inp-lastname" />
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-4">
                <label for="">Subject</label>
            </div>
            <div class="col-sm-8">
                <input type="text" class="form-control" placeholder="Nhập subject ..." id="inp-subject" />
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-4">
                <label for="">Country</label>
            </div>
            <div class="col-sm-8">
                <select name="Customertype" id="select-country" class="form-control">
                    <option value="VN">Việt Nam</option>
                    <option value="USA">USA</option>
                    <option value="AUS">Australia</option>
                    <option value="CAN">Canada</option>
                </select>
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-4">
                <label for="">Customer type</label>
            </div>
            <div class="col-sm-8">
                <select name="Customertype" id="select-customertype" class="form-control">
                    <option value="Standard">Standard</option>
                    <option value="Gold">Gold</option>
                    <option value="Premium">Premium</option>
                </select>
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-4">
                <label for="">Register status</label>
            </div>
            <div class="col-sm-8">
                <select name="registerStatus" id="select-register-status" class="form-control">
                    <option value="New">New</option>
                    <option value="Accepted">Accepted</option>
                    <option value="Denied">Denied</option>
                </select>
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-4">

            </div>
            <div class="col-sm-8">
                <button type="button" class="btn btn-success w-25" id="btn-update-user">Update User</button>
                <button type="button" class="btn btn-success w-25" id="btn-huy">Huỷ bỏ</button>
            </div>
        </div>
    </div>
</body>
<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    var gFirstName = $("#inp-firstname");
    var gLastName = $("#inp-lastname");
    var gCountry = $("#select-country");
    var gSubject = $("#inp-subject");
    var gCustomerType = $("#select-customertype");
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function(){
        onPageLoading();
    });
    $("#btn-update-user").click(function(){
        var vDataObj = getDataForm();
        var vValid = checkDataForm(vDataObj);
        if (vValid){
            callApiUpdateDataUser(vDataObj);
        }
    });
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading(){
        var vUrlString = window.location.href;
        var vUrl = new URL(vUrlString);

        var vId = vUrl.searchParams.get("id");
        console.log(vId);
        callApiDataUserById(vId);
    }
    
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    function callApiDataUserById(paramUserId){
        $.ajax({
            url: "http://203.171.20.210:8080/crud-api/users/" + paramUserId,
            type: "GET",
            success: function(DataUserObj){
                console.log(DataUserObj);
                showDataUserToForm(DataUserObj);
            },
            error: function(ajaxContext){
                console.log(ajaxContext.status);
            },
        });
    }
    function showDataUserToForm(paramUser){
        $("#inp-firstname").val(paramUser.firstname);
        $("#inp-lastname").val(paramUser.lastname);
        $("#select-country").val(paramUser.country);
        $("#inp-subject").val(paramUser.subject);
        $("#select-customertype").val(paramUser.customerType);
        $("#select-register-status").val(paramUser.registerStatus);
    }
    function getDataForm(){
        //debugger;
        var vUpdateObj = new Object();
        vUpdateObj.firstname = $.trim(gFirstName.val());
        vUpdateObj.lastname = $.trim(gLastName.val());
        vUpdateObj.country = gCountry.val();
        vUpdateObj.subject = $.trim(gSubject.val());
        vUpdateObj.customerType = gCustomerType.val();
        
        return vUpdateObj;
    }
    function getUpdateUserId(){
        var vId= null;
        var vUrl = new URL(window.location.href);
        vId = vUrl.searchParams.get("id");
        return vId;
    }
    function checkDataForm(paramDataForm){
        if(paramDataForm.firstname == ""){
            alert("Nhập firstname");
            return false;
        }
        if(paramDataForm.lastname == ""){
            alert("Nhập lastname");
            return false;
        }
        if(paramDataForm.country == ""){
            alert("Nhập country");
            return false;
        }
        if(paramDataForm.subject == ""){
            alert("Nhập subject");
            return false;
        }
        if(paramDataForm.customerType == ""){
            alert("Nhập customerType");
            return false;
        }
        return true;
    }
    function callApiUpdateDataUser(paramEditedObj){
        //debugger;
        var vUserId = getUpdateUserId();

        var vJsonString = JSON.stringify(paramEditedObj);
        //console.log(vJsonString);
        $.ajax({
            url:"http://203.171.20.210:8080/crud-api/users/" + vUserId,
            method: 'PUT',
            contentType: "application/json; charset=utf-8",
            data: vJsonString,
            success: function(paramResponse){
                alert("Updated!!!");
                window.location.href = "task32.50.html";
                console.log(JSON.stringify(paramResponse, true, 2));
            },
            error: function(ajaxContext){
                console.log(ajaxContext);
            }
        });
    }
</script>
</html>